Imports FarPoint.Win.Spread
Public Class S3DateInput
    Inherits FarPoint.Win.Spread.CellType.GeneralCellType

    Dim se As s3DateSubEditor

    Public Overrides Function Parse(ByVal s As String) As Object
        Dim strTmp As String = s
        If Not IsDate(strTmp) And strTmp.Length >= 8 Then
            strTmp = strTmp.Substring(0, 2) + "." + strTmp.Substring(2, 2) + "." + strTmp.Substring(4, 4)
        End If
        If Not IsDate(strTmp) Then
            Return MyBase.Parse(s)
        Else
            Return CDate(strTmp).Date
        End If

    End Function

    Public Overrides Sub ShowSubEditor()
        MyBase.ShowSubEditor()
    End Sub

    Sub New()
        se = New s3DateSubEditor
        MyBase.SubEditor = se
    End Sub
    Public Overrides Function Format(ByVal mydata As Object) As String
        Dim strTmp As String = ""
        If Not IsDate(mydata) Then
            If TypeOf mydata Is Double Or TypeOf mydata Is Integer Then
                strTmp = mydata.ToString
                If strTmp.Length = 5 Then strTmp = "0" + strTmp
            End If
            If TypeOf mydata Is String Then
                strTmp = mydata.ToString
            End If
            If Not IsDate(strTmp) Then
                Dim strtmp1 As String = strTmp
                If strTmp.Length > 3 Then strTmp = strTmp.Substring(0, 2) + "." + strTmp.Substring(2, 2)
                If strtmp1.Length > 6 Then
                    strTmp += "." + strtmp1.Substring(4, strtmp1.Length - 4)
                Else
                    If strtmp1.Length >= 6 Then strTmp += "20." + strtmp1.Substring(4, 2)
                End If
            End If
            If Not IsDate(strTmp) Then
                Return mydata.ToString
            Else
                Return String.Format(MyBase.FormatString, strTmp)
            End If
        Else
            Return CType(mydata, Date).ToString(MyBase.FormatString())
        End If

    End Function
End Class
